/*
mysql> describe  datah;
+-------------+------------------+------+-----+-------------------+-----------------------------+
| Field       | Type             | Null | Key | Default           | Extra                       |
+-------------+------------------+------+-----+-------------------+-----------------------------+
| id          | int(10) unsigned | NO   | PRI | NULL              | auto_increment              |
| bv          | double(6,2)      | YES  |     | NULL              |                             |
| tv          | double(6,2)      | YES  |     | NULL              |                             |
| ts          | timestamp        | NO   | MUL | CURRENT_TIMESTAMP | on update CURRENT_TIMESTAMP |
| cc          | double(6,2)      | YES  |     | NULL              |                             |
| av          | double(6,2)      | YES  |     | NULL              |                             |
| ac          | double(6,2)      | YES  |     | NULL              |                             |
| op          | double(6,2)      | YES  |     | NULL              |                             |
| svmp        | double(6,2)      | YES  |     | NULL              |                             |
| swoc        | double(6,2)      | YES  |     | NULL              |                             |
| swpm        | double(6,2)      | YES  |     | NULL              |                             |
| bt          | int(2) unsigned  | YES  |     | NULL              |                             |
| hst         | int(2) unsigned  | YES  |     | NULL              |                             |
| chargestate | int(2) unsigned  | YES  |     | NULL              |                             |
| ledstate    | int(2) unsigned  | YES  |     | NULL              |                             |
| ddate       | datetime         | YES  | MUL | NULL              |                             |
| dtime       | datetime         | YES  |     | NULL              |                             |
| loadamps    | double(6,2)      | YES  |     | NULL              |                             |
| streetpower | double(6,2)      | YES  |     | 0.00              |                             |
| meterwhr    | int(2)           | YES  |     | NULL              |                             |
| inverterctl | int(1)           | YES  |     | NULL              |                             |
| lvcomp      | int(2)           | YES  |     | NULL              |                             |
+-------------+------------------+------+-----+-------------------+-----------------------------+
22 rows in set (0.01 sec)
*/

#include <wiringSerial.h>
#include <stdio.h>
#include </usr/include/curl/curl.h>
#include <string.h>
#include "stdio.h"
#include "stdlib.h"
#include "strings.h"
#include <signal.h>
#include <time.h>
#include </usr/include/mysql/mysql.h>

#define CHANNEL 0

char ubuf[1000],dstr[100],tdstr[100];

MYSQL mycon, *myc1,*myp;
MYSQL_RES *res, *res_wsh;
MYSQL_ROW row, row_wsh;
MYSQL_FIELD *myf;


struct string {
  char *ptr;
  size_t len;
};

struct string ss;

time_t rawtime;
struct tm tm;

void init_string( struct string *);
float parse_float (char *, int);
char bbuf[1000],sqlbuf[1000];
unsigned char buf[100];
char url[1000];



main()
{
float bv,tv,cc,av,ac,op,svmp,swoc,swpm,bt,hst,chargestate,ledstate,loadamps, vcutoff, vcutin;
int f,i,j,k,n, ioverride, icmd,whr;
int datah_id;
unsigned char c;
printf("\n opening /dev/ttyUSB0 ...");
f = serialOpen("/dev/ttyUSB0",115200);
if (f == -1)
	{
	printf("\n cant open /dev/ttyUSB0 - trying /dev/ttyUSB1...");
	f = serialOpen("/dev/ttyUSB1",115200);
	if (f == -1)
		{
		printf("\n cant open /dev/ttyUSB1 either - fuck it, time to die.");
		exit(0);
		}
	}
signal(SIGHUP,SIG_IGN);
c = 'b';
loadamps=0.0;
system("gpio mode 0 OUTPUT");				// enable drive on wiring pin 0
system("gpio write 0 1");				// switch inverter ON
while(1)
	{
	rawtime = time(NULL);
	serialFlush(f);
	serialPutchar(f,c);
	delay(10);
	n=0;
	while (serialDataAvail(f) > 0)
		{
		buf[n] = serialGetchar(f);
		n++;
		if  (n > 50)
			n=50;
		}
	if (n > 0)
		{
		i = (buf[0] << 8) + buf[1];
		whr = (buf[2] << 8) + buf[3];
		k = (buf[4] << 8) + buf[5];
		printf("\n%d,%d,%d",i,j,k);
		loadamps = (float)(i-511) * 0.132;	// was 0.1176, 0.132
		}

		// record the home ip at the bq server
	system("wget -T 10 -t 1 -O /dev/null smtp.bqdesign.com.au/homeip.php");

	init_string(&ss);
        uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=38&RHI=0&RLO=1");
        bv = parse_float(ss.ptr,1);
        free(ss.ptr);
        init_string(&ss);
        uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=51&RHI=0&RLO=1");
        tv = parse_float(ss.ptr,1);
        free(ss.ptr);
        init_string(&ss);
        uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=39&RHI=0&RLO=1");
        cc = parse_float(ss.ptr,2);
        free(ss.ptr);
        init_string(&ss);
        uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=27&RHI=0&RLO=1");
        av = parse_float(ss.ptr,1);
        free(ss.ptr);
        init_string(&ss);
        uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=29&RHI=0&RLO=1");
        ac = parse_float(ss.ptr,2);
        free(ss.ptr);
        init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=61&RHI=0&RLO=1");
                svmp = parse_float(ss.ptr,1);
                free(ss.ptr);
                init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=62&RHI=0&RLO=1");
                swoc = parse_float(ss.ptr,1);
                free(ss.ptr);
                init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=60&RHI=0&RLO=1");
                swpm = parse_float(ss.ptr,3);
                free(ss.ptr);
                init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=37&RHI=0&RLO=1");
                bt = parse_float(ss.ptr,4);
                free(ss.ptr);
                init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=35&RHI=0&RLO=1");
                hst = parse_float(ss.ptr,4);
                free(ss.ptr);
                init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=50&RHI=0&RLO=1");
                chargestate = parse_float(ss.ptr,5);
                free(ss.ptr);
                init_string(&ss);
                uc("http://172.16.0.54/MBCSV.cgi?ID=1&F=4&AHI=0&ALO=49&RHI=0&RLO=1");
                ledstate = parse_float(ss.ptr,5);
                free(ss.ptr);

                dstr[0] = 0;
                tdstr[0] = 0;

                tm = *localtime(&rawtime);
                sprintf(dstr,"%4d%02d%02d",1900+tm.tm_year,1+tm.tm_mon,tm.tm_mday);
                sprintf(tdstr,"%4d%02d%02d%02d%02d%02d",1900+tm.tm_year,1+tm.tm_mon,tm.tm_mday,tm.tm_hour, tm.tm_min,tm.tm_sec);

								myp = mysql_init(&mycon);
                myp = mysql_real_connect(&mycon,"localhost","root","ibs142","mppt",0,NULL,0);
                if (myp == NULL)
                        {
                        printf("error connecting to mysql server ");
                        exit(0);
                        }
                bbuf[0]=ubuf[0]=sqlbuf[0]=0;
                sprintf(bbuf,"insert into datah (bv, tv, ts, cc, av, ac, op, svmp, swoc, swpm, bt, hst, chargestate, ledstate, ddate, dtime, loadamps,streetpower,meterwhr,inverterctl)");
                sprintf(ubuf," VALUES (%f,%f,%s,%f,%f,%f,0.0,%f,%f,%f,%f,%f,%f,%f,%s,%s,%f,%d,%d,-1);",bv,tv,tdstr,cc,av,ac,svmp,swoc,swpm,bt,hst,chargestate,ledstate,dstr,tdstr,loadamps,k,whr);
                strcat(sqlbuf,bbuf);
                strcat(sqlbuf,ubuf);
                j = mysql_query(&mycon,sqlbuf);
                // get id of this inserted record
                j = mysql_query(&mycon,"select id from datah order by id desc limit 1;");
                res = mysql_store_result(&mycon);
                row = mysql_fetch_row(res);
                datah_id = atoi(row[0]);
                printf("\n\n%s\n\n",sqlbuf);
                fflush(stdout);

                // inverter control
								
								j = mysql_query(&mycon,"select fnvcutoff, fnvcutin,fnistatus from dinfo where id=1;");
                res = mysql_store_result(&mycon);
                row = mysql_fetch_row(res);
                vcutoff = atof(row[0]);
                vcutin = atof(row[1]);
                i = atoi(row[2]);			// read current switch status  ON=1 OFF=0 
                
                printf("\n inverter = %d, battery %fV, cutoff voltage = %fV, cutin voltage = %fV",i,bv,vcutoff,vcutin);
								j = mysql_query(&mycon,"select fnioverride, fniocmd from dinfo where id=1;");
                res = mysql_store_result(&mycon);
                row = mysql_fetch_row(res);
                ioverride = atoi(row[0]);
                icmd = atoi(row[1]);
                if (ioverride == 1)
                	{
                	i = icmd;
                	printf("\n inverter override in control, set to %d ",icmd);
                	}
								else
									{
									if (bv < vcutoff)
                		{
                		i = 0;
										printf("\n LV - stop inverter");  
										system("gpio mode 0 OUTPUT");
										sleep(2);
                		system("gpio write 0 0");				// switch inverter OFF              	
                		}
            			
            			if (bv > vcutin && i == 0)
            				{
            				i = 1;
            				printf("\n  restart inverter");
            				system("gpio mode 0 OUTPUT");
										sleep(2);
										system("gpio write 0 1");				// switch inverter ON
            				}    	
            			}
            
                // write inverter switch status
                sprintf(bbuf,"update dinfo set fnistatus = %d where id=1;",i);
                j = mysql_query(&mycon,bbuf);
                printf("\n\n%s\n\n",bbuf);    
                fflush(stdout);
                
                sprintf(bbuf,"update datah set inverterctl = %d where id = %d;",i,datah_id);
								j = mysql_query(&mycon,bbuf);
                mysql_close(&mycon);
	sleep(120 - (time(NULL) - rawtime) );
	}
serialClose(f);
}







float parse_float(char *s,int t)
        {
        float a,b,c;
        char *p,*q;
        int i;
        p = s + 6;
        a = atof(p);

        while(*p != ',')
                p++;
        p++;
        b = atof(p);
	if (t == 1)                     // voltage
                {
                c = (a*256.0 + b) * 5.493e-3; 
                return c;
                }
        if (t == 2)                     // amps
                {
                c = (a*256.0 + b) * 2.441e-3;
                return c;
                }
        if (t == 3)                     // Watts
                {
                c = (a * 256.0 + b) * 0.10986;
                return c;
                }
        if (t == 4)                     // temperature degC
                return b;               // not correct for neg temps.
        if (t == 5)                     // digital, led state, charge state..
                return b;
        return 0.0;
        }


void init_string(struct string *s) 
	{
  	s->len = 0;
  	s->ptr = malloc(s->len+1);
  	if (s->ptr == NULL) 
		{
    		fprintf(stderr, "malloc() failed\n");
    		exit(EXIT_FAILURE);
  		}
  	s->ptr[0] = '\0';
}


size_t writefunc(void *ptr, size_t size, size_t nmemb, struct string *s)
{
  size_t new_len = s->len + size*nmemb;
  s->ptr = realloc(s->ptr, new_len+1);
  if (s->ptr == NULL) {
    fprintf(stderr, "realloc() failed\n");
    exit(EXIT_FAILURE);
  }
  memcpy(s->ptr+s->len, ptr, size*nmemb);
  s->ptr[new_len] = '\0';
  s->len = new_len;

  return size*nmemb;
}


uc(char *surl)
        {
  CURL *curl;
  CURLcode res;
  curl = curl_easy_init();
  if(curl) {
    curl_easy_setopt(curl, CURLOPT_URL, surl);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writefunc);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, &ss);
    res = curl_easy_perform(curl);
    /* always cleanup */
    curl_easy_cleanup(curl);
  }
  return 0;
}


