function getWidth() {
  if (self.innerWidth) {
    return self.innerWidth;
  }

  if (document.documentElement && document.documentElement.clientWidth) {
    return document.documentElement.clientWidth;
  }

  if (document.body) {
    return document.body.clientWidth;
  }
}

function getxml()
	{
	try
		{
		xmlHttp=new XMLHttpRequest();
		}
	catch (e)
		{
	  	try
			{
	    		xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
	    		}
	  	catch (e)
			{
	    		try
				{
	      			xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
	      			}
	    		catch (e)
				{
				alert("Your browser does not support AJAX!");
				return false;
				}
			}
		}
	return xmlHttp;
	}

function rupcbox(id,val,u)
	{
	var xmlHttp,p,c,i,s,v,u,nuval;
	v = document.getElementById("cbuttons");
	xmlHttp = getxml();
	xmlHttp.onreadystatechange=function()
		{
		if(xmlHttp.readyState==4)
			{
			}
		}
	p = "?id=" + val + "&v=" + u;
	xmlHttp.open('GET',"dflags.php" + p,true);
	
	xmlHttp.send();	
	}




function dline(x1,y1,x2,y2,dotRadius,dotCount,dotColor){
          var dx=x2-x1;
          var dy=y2-y1;
          var spaceX=dx/(dotCount-1);
          var spaceY=dy/(dotCount-1);
          var newX=x1;
          var newY=y1;
          for (var i=0;i<dotCount;i++){
                  drawDot(newX,newY,dotRadius,dotColor);
                  newX+=spaceX;
                  newY+=spaceY;              
           }
        }
function drawDot(x,y,dotRadius,dotColor){
            ctx.beginPath();
            ctx.arc(x,y, dotRadius, 0, 2 * Math.PI, false);
            ctx.fillStyle = dotColor;
            ctx.fill();              
        }

function pad(n) {
    return (n < 10) ? ("0" + n) : n;
}


function getMousePos(canvas, evt) 
	{
    var rect = c.getBoundingClientRect();
	lmx = evt.clientX;
	lmy = evt.clientY;
    return {
        	x: evt.clientX - rect.left,
          	y: evt.clientY - rect.top
        	};
    }


	
c.addEventListener('mousemove', function(evt) 
	{
    var mousePos = getMousePos(c, evt);
	mousex = mousePos.x;
	mousey = mousePos.y;
    var message = 'Mouse position: ' + mousePos.x + ',' + mousePos.y;
    writeMessage( message);
    }, false);


function xax(x1,y1,x2,y2,y3,i,ygo)
	{
	ctx.fillStyle="#FF0000";
	ctx.strokeStyle="#FF0000";
	ctx.moveTo(x1,y1);
	ctx.lineTo(x2,y2);
	ctx.fillText(i,x1,y3);
	dline(x1,yg+ygo,x1,ygo,1,100,'#FF8080');
	ctx.stroke();
	}


function init_things()
	{
	var y1, y2,x1,x2,y3,i,oldx1;
	xx = c.width;
	yy = c.height;
	//yy = 600;

	//naxes = 4;
	
	//
	// obtain the count of unique axes types
	//
	for(i=0; i < 35; i++)
		axdone[i] = 0;
	naxes = 1;
	for(i=1; i <= nselflags; i++)
		{
		if (axdone[gparam[3][selflag[i]]] == 0)
			{
			axdone[gparam[3][selflag[i]]] = 1;
			naxes = naxes + 1;
			}
		}
	
	xg =  xx - (50 * naxes);
	yg =  yy - 60;
	xgo = 10;
	ygo = 40; 
	ctx.beginPath();
	ctx.strokeRect(xgo,ygo,xg,yg);
	ncurves = 0;
	naxes=0;
	// time axis
	ctx.textAlign="center"; 
	ctx.font="15px Arial"; 
	ctx.globalAlpha = 1.0;
	for (i=1; i < 24; i ++)
		{
		y1 = ygo + yg + 10;
		y2 = ygo + yg - 10;
		x1 = xgo + (i / 24.0)*xg;
		x2 = x1;
		y3 = ygo + yg + 15;
		xax(x1,y1,x2,y2,y3,i,ygo);
		}
	x1old = xgo + biga[0][0] * xg;
	for(i=0; i < npoints; i++)
		{
		x1 = xgo + biga[0][i] * xg;
		tyi = biga[nselflags+1][i];
	
		 if (tyi == 3)
	  		{
	  		fs = "#E0E0E0";
			ss = "#E0E0E0";	
	  		}
	  
	  	if (tyi == 5)
	  		{
	  		fs="#FFE0E0";
			ss="#FFE0E0";
	  		}
		
		if (tyi == 6)
	  		{
	  		fs="#E0FFE0";
			ss="#E0FFE0";
	  		}
		
		if (tyi == 7)
	  		{
	  		fs="#E0E0FF";
			ss="#E0E0FF";
	  		}
	  	ctx.fillStyle = fs;	
		ctx.fillRect(oldx1,ygo,x1-oldx1,yg);
		oldx1 = x1;
		}	
	for(i=0; i < 35; i++)
		axdone[i] = 0;
		
	ctx.fillStyle="#000000";
	ctx.strokeStyle="#000000";	
	ctx.fillText(ud,130,25);
	ctx.stroke();
	}

function do_curve(idx,j)
	{
	var cmin = gparam[0][idx];
	var cmax = gparam[1][idx];
	ctx.beginPath();
	ctx.fillStyle="#FF0000";
	ctx.strokeStyle=gparam[2][idx];
	var f = 0, i;
	var x1 = 0.0,y1 = 0.0, ty = 0.0;
	for(i=0; i < npoints; i++)
		{
		x1 = xgo + biga[0][i] * xg;
		ty = biga[j][i];
		y1 = ygo + yg *(1.0  - (ty - cmin)/(cmax - cmin));
		if (y1 < ygo)
			y1 = ygo;
		if (f == 0)
			ctx.moveTo(x1,y1);
		else	
			ctx.lineTo(x1,y1);
		f = 1;
		}
	ctx.stroke();
	}

function do_scale(idx)
	{
	var x1, j=0.0;
	var cmin = gparam[0][idx];
	var cmax = gparam[1][idx];
	var dtick = gparam[4][idx];
	
	naxes = naxes + 1;
	ctx.fillStyle="#000000";
	ctx.strokeStyle="#000000";
	ctx.beginPath();
	ctx.textAlign="right";
	ctx.textBaseline="middle";
	x1 =  xg + 50 * naxes;
	ctx.moveTo(x1+5,ygo);
	ctx.lineTo(x1+5,ygo + yg);	
		
	for(j = cmin; j <= cmax; j += dtick)
			{
			y3 = ygo + yg *(1.0  - (j - cmin)/(cmax - cmin));
			ctx.fillText(j,x1,y3);
			ctx.moveTo(x1+5,y3);
			ctx.lineTo(x1+10,y3);
			}

	y3 = y3 - 30.0;
	ctx.fillText(gparam[7][idx],x1+20,y3);
	ctx.stroke();	
	axdone[gparam[3][idx]] = x1;
	}
	

function writeMessage( message) 
	{    
	var u = 0.0;
	var tx = 0.0;
	var cy = 0.0;
	cy = 1.0 - (mousey - ygo) / yg;
	if (cy < 0.0) cy = 0.0;
	if (cy > 1.0) cy = 1.0;  
	var m = 720*(mousex-xgo)/xg;
	var i = Math.floor(m);
	if (i < 0.0) i = 0.0;
	if (i > mdat) i = mdat;
	var tmin = Math.floor(60*(i/30 - Math.floor(i/30)));
	var thour = Math.floor(i/30);
	ctx.putImageData(imageData,0,0);
	
	ctx.beginPath();
	ctx.strokeStyle="#000000";
	ctx.fillStyle="#000000";
	if (mousex > xgo && mousex < (xg+xgo))
		{
		ctx.moveTo(mousex,ygo);
		ctx.lineTo(mousex,yg+ygo);
		}
	if (mousey > ygo && mousey < (yg+ygo))
		{
		ctx.moveTo(xgo,mousey);
		ctx.lineTo(xx,mousey);
		}
	ctx.stroke();
	var j,x1,ty,k,y3;
	ncurves = 1;
	ctx.beginPath();
	y3 = 60.0 + 20.0 * ncurves;
	x1 =  20.0;
	ctx.clearRect(x1,y3-10,200,20);
	ctx.font="15px Arial";
	ctx.fillStyle="#FF0000";
	ctx.textAlign="left";
	ctx.fillText("time " + pad(thour) + ":" + pad(tmin) ,x1,y3);
	ctx.stroke();
	
	ncurves = 2;	
	var cmin, cmax;
	for(j=1; j <= nselflags; j++)
		{
		k = selflag[j];
		ctx.beginPath();
		y3 = 60.0 + 20.0 * ncurves;
		x1 =  20.0;
		ctx.clearRect(x1,y3-10,200,20);
		ctx.fillStyle=gparam[2][k];
		ctx.textAlign="left";
		ctx.font="15px Arial";
		ctx.fillText(gparam[5][k] + " " + biga[j][i] + " " + gparam[6][k],x1,y3);
		ctx.stroke();
		cmin = gparam[0][k];
		cmax = gparam[1][k];
		ctx.beginPath();
		x1 =  axdone[gparam[3][k]] - 10;
		ccolour = '#000000';
		ctx.fillStyle="#000000";
		ctx.textAlign="left"; 
		ctx.font="10px sans-serif";
		ty = cmin + cy * (cmax-cmin);
		ctx.fillText(ty.toFixed(2),x1,25);
		ctx.stroke();
		ncurves = ncurves + 1;
		}	
	}
function resizecanvas()
	{
	c.width = window.innerWidth-20;
	c.height = window.innerHeight - 200;
	init_things();
	var i;
	for(i=1; i <= nselflags; i++)
		{
		do_curve(selflag[i],i);
		if(axdone[gparam[3][selflag[i]]] == 0)
			do_scale(selflag[i]);	
		}
	imageData=ctx.getImageData(0,0,xx+100,yy);
	}
	
window.addEventListener('resize', resizecanvas, false);
resizecanvas();