#include "Arduino.h"

int i,j,k,sbit[80],v[8];
unsigned long pp;
unsigned int v1, v2, v3,q;
float apower,acurrent;
long acount;
char buf[100];
unsigned long counter = 0;
unsigned long lastImpulse = 0;
unsigned long diffImpulse = 0;
long currentWatt = 0;

void blink();

void setup()
{
  apower=0.0;
  acurrent = 0;
  acount = 0;
  q=0;
  Serial.begin(115200);
  attachInterrupt(1, blink, FALLING);
  pinMode(13,OUTPUT);
} 


void loop()
  {
  int c;
  v2 = (unsigned int)counter;
  v3 = (unsigned int)currentWatt;
  q++;
  digitalWrite(13,digitalRead(3));
  if(q > 1000)
    {
    q=0;
    acurrent += (float)analogRead(0);
    acount++;
    }
  if (Serial.available()) 
    {
    c = Serial.read();
    if (c == 'b')
      {
      acurrent = acurrent /  (float)acount;
      v1 = (int)acurrent;
      acurrent = 0.0;
      acount = 0;
      counter = 0;
      buf[0] = v1 >> 8;
      buf[1] = v1 & 255;
      buf[2] = v2 >> 8;
      buf[3] = v2 & 255;
      buf[4] = v3 >> 8;
      buf[5] = v3 & 255;    
      Serial.write(buf,6);
      }
    if (c == 'a')
      {
      acurrent = acurrent /  (float)acount;
      v1 = (int)acurrent;
      acurrent = 0.0;
      acount = 0;
      Serial.print(v1);
      Serial.print(", ");
      Serial.print(v2);
      Serial.print(", ");
      Serial.println(v3);
      }  
    }
  }


void blink() 
{
  unsigned long currentImpulse = millis();
  counter++;
  // Calculate current Watt usage by measuring the time difference between two impulses
  if (lastImpulse != 0) { // we can now calculcate
    if (currentImpulse > lastImpulse) {
      diffImpulse = currentImpulse - lastImpulse;
      currentWatt = long((3600UL * 1000UL) / diffImpulse);
    } else if (lastImpulse > currentImpulse) { // overflow
      diffImpulse = currentImpulse + (4294967295UL - lastImpulse);
      currentWatt = long((3600UL * 1000UL) / diffImpulse);
    } else {
      // We should never get here
      diffImpulse = 0;
      currentWatt = -1;
    }
  }
  lastImpulse = currentImpulse; 
}

